#create the extra tables
echo "200 link_slow" >> /etc/iproute2/rt_tables
echo "201 link_medium" >> /etc/iproute2/rt_tables

#add the default routes to the new tables
ip route add default via 1.0.0.2 table link_slow
ip route add default via 3.0.0.2 table link_medium

#add the routing policies. This time I don’t care about the order, as netfilter will take care of the required priorities 
ip rule add pri 20000 fwmark 1 table link_slow
ip rule add pri 21000 fwmark 2 table link_medium
ip rule add pri 22000 fwmark 3 table main	
#set ENV variables
SLOW="-j MARK --set-mark 1"
MEDIUM="-j MARK --set-mark 2"
FAST="-j MARK --set-mark 3"

#set the netfilter rules
iptables -t mangle -A PREROUTING -m mark --mark 0 -p udp --dport 53 $SLOW
iptables -t mangle -A PREROUTING -m mark --mark 0 -p tcp --dport 22 $FAST
iptables -t mangle -A PREROUTING -m mark --mark 0 -p tcp -m multiport --dports 40000:40100 $MEDIUM
iptables -t mangle -A PREROUTING -m mark --mark 0 -s 10.0.0.101 $MEDIUM
iptables -t mangle -A PREROUTING -m mark --mark 0 -p tcp -m multiport --dports 80,433 $MEDIUM

#the last two policies (from LAN A and LAN B) can be configured with ip rule “from” selector, with priority lower than the “fwmark” rules
ip rule add pri 23000 from 10.0.0.0/24 table link_slow
ip rule add pri 23000 from 10.1.0.0/24 table link_medium
